# gift certificate sql statements
giftCertificate.find.byId = select * from gift_certificate where id=?;
giftCertificate.delete.byId = delete from gift_certificate where id =?;
giftCertificate.update.byId = update gift_certificate set %s last_update_date=? where id = ?;
giftCertificate.find.all = select * from gift_certificate limit ? offset ?;
giftCertificate.insert = insert into gift_certificate(name, description, price, duration, create_date, last_update_date) \
  values(?,?,?,?,?,?);
giftCertificate.insert.giftCertAndTag = insert into gift_certs_tags(gift_cert_id, tag_id) values(?, ?);
giftCertificate.count.giftCertificatesAndTagsByTagNames = select count(*) from gift_certificate where id in \
  (select gift_certs_tags.gift_cert_id from gift_certs_tags where gift_certs_tags.tag_id in \
  (select tag.id from tag where tag.name in (%1$s)) group by gift_certs_tags.gift_cert_id having \
  count(gift_certs_tags.gift_cert_id) = %2$d);
giftCertificate.find.sortedGiftCertificatesAndTagsByTagNames = select * from gift_certificate where id in \
  (select gift_certs_tags.gift_cert_id from gift_certs_tags where gift_certs_tags.tag_id in \
  (select tag.id from tag where tag.name in (%1$s)) group by gift_certs_tags.gift_cert_id having \
  count(gift_certs_tags.gift_cert_id) = %2$d) order by %3$s limit ? offset ?;
giftCertificate.find.giftCertificatesAndTagsByTagNames = select * from gift_certificate where id in \
  (select gift_certs_tags.gift_cert_id from gift_certs_tags where gift_certs_tags.tag_id in \
  (select tag.id from tag where tag.name in (%1$s)) group by gift_certs_tags.gift_cert_id having \
  count(gift_certs_tags.gift_cert_id) = %2$d) limit ? offset ?;
giftCertificate.count.giftCertificatesAndTagsByPartOfName = select count(*) from gift_certificate where name like '%s';
giftCertificate.find.sortedGiftCertificatesAndTagsByPartOfName = select * from gift_certificate where name \
  like '%1$s' order by %2$s limit ? offset ?;
giftCertificate.find.giftCertificatesAndTagsByPartOfName = select * from gift_certificate where name like '%s'\
  limit ? offset ?;
giftCertificate.find.sortedGiftCertificatesAndTagsByPartOfDesc = select * from gift_certificate where description \
  like '%1$s' order by %2$s limit ? offset ?;
giftCertificate.count.giftCertificatesAndTagsByPartOfDesc = select count(*) from gift_certificate where description \
  like '%s';
giftCertificate.find.giftCertificatesAndTagsByPartOfDesc = select * from gift_certificate where description like '%s'\
  limit ? offset ?;
giftCertificate.delete.all = delete from gift_certificate;
# h2 reset auto-increment
giftCertificate.reset.autoincrement=alter table gift_certificate alter id restart with 1;
# mysql reset auto-increment
#giftCertificate.reset.autoincrement=alter table gift_certificate auto_increment=1;
giftCertificate.count.all=select count(*) from gift_certificate;
giftCertificate.find.tagGiftCertificates = select * from gift_certificate join gift_certs_tags on \
  gift_certificate.id = gift_certs_tags.gift_cert_id where gift_certs_tags.tag_id = %d limit ? offset ?;
giftCertificate.count.tagGiftCertificates = select count(*) from gift_certificate join gift_certs_tags on \
  gift_certificate.id = gift_certs_tags.gift_cert_id where gift_certs_tags.tag_id = %d;

# tag sql statements
tag.find.giftCertificateTagsPage = select * from tag join gift_certs_tags on tag.id = gift_certs_tags.tag_id \
  where gift_certs_tags.gift_cert_id = %d limit ? offset ?;
tag.count.giftCertificateTags = select count(*) from tag join gift_certs_tags on tag.id = gift_certs_tags.tag_id \
  where gift_certs_tags.gift_cert_id=%d;
tag.find.giftCertificateTags = select * from tag join gift_certs_tags on tag.id = gift_certs_tags.tag_id \
  where gift_certs_tags.gift_cert_id = ?;
tag.find.byId = select * from tag where id = ?;
tag.find.byName = select * from tag where name = ?;
tag.delete = delete from tag where id = ?;
tag.count.all = select count(*) from tag;
tag.find.all = select * from tag limit ? offset ?;
tag.count.mostWidelyUsed = select count(distinct t.id) from tag t \
  left join gift_certs_tags gct on gct.tag_id = t.id \
  left join gift_certificate_order ogc on ogc.gift_certificate_id = gct.gift_cert_id \
  right join (select distinct ogct.total_cost from gift_certificate_order ogct order by ogct.total_cost desc) n \
  on ogc.total_cost = n.total_cost where t.id is not null;
tag.find.mostWidelyUsed= select distinct t.* from tag t \
  left join gift_certs_tags gct on gct.tag_id = t.id \
  left join gift_certificate_order ogc on ogc.gift_certificate_id = gct.gift_cert_id \
  right join (select distinct ogct.total_cost from gift_certificate_order ogct order by ogct.total_cost desc) n \
  on ogc.total_cost = n.total_cost where t.id is not null limit ? offset ?;
tag.find.topMostWidelyUsed=select distinct t.* from tag t \
  left join gift_certs_tags gct on gct.tag_id = t.id \
  left join gift_certificate_order ogc on ogc.gift_certificate_id = gct.gift_cert_id \
  right join (select distinct ogct.total_cost from gift_certificate_order ogct order by ogct.total_cost desc) n \
  on ogc.total_cost = n.total_cost where t.id is not null limit ?
tag.insert = insert into tag(name) values(?);
tag.delete.all = delete from tag;
# h2 reset auto-increment
tag.reset.autoincrement = alter table tag alter id restart with 1;
# mysql reset auto-increment
#tag.reset.autoincrement = alter table tag auto_increment = 1;
# user sql statements
user.insert = insert into user(full_name, email, password, created_date, last_updated_date) values(?, ?, ?, ?, ?);
user.count.all = select count(*) from user;
user.find.all = select * from user limit ? offset ?;
user.find.byId = select * from user where id = ?;
user.delete.byId = delete from user where id = ?;
user.delete.all = delete from user;
# h2 reset auto-increment
user.reset.autoincrement = alter table user alter id restart with 1;
# mysql reset auto-increment
#user.reset.autoincrement = alter table user auto_increment = 1;

# order sql statements
order.insert = insert into gift_certificate_order(total_cost, quantity, status, ordered_date, last_updated_date, \
  owner_id, gift_certificate_id) values(?, ?, ?, ?, ?, ?, ?);
order.count.byGiftCertificateId = select count(*) from gift_certificate_order where gift_certificate_id = %d;
order.find.byGiftCertificateId = select * from gift_certificate_order where gift_certificate_id = %d \
  limit ? offset ?;
order.find.byOwnerId=select * from gift_certificate_order where owner_id = %d limit ? offset ?;
order.count.byOwnerId=select count(*) from gift_certificate_order where owner_id = %d;
order.find.byId=select * from gift_certificate_order where id=?;
order.delete.all=delete from gift_certificate_order;
order.delete.byId = delete from order where id = ?;
# h2 reset auto-increment
order.reset.autoincrement = alter table gift_certificate_order alter id restart with 1;
# mysql reset auto-increment
#user.reset.autoincrement = alter table gift_certificate_order auto_increment = 1;

